Redmine.pm memory leak

2008-04-24 13:02 - Nikolay Dimitrov

Status: Closed Start date: 2008-04-24

Priority: High Due date:  

Assignee:  % Done: 100%

Category: Permissions and roles Estimated time: 0.00 hour

Target version:    

Resolution:  Affected version:  

Description

SW Setup:

svn over apache dav

Redmine.pm authentication method

PostgreSQL database

repository and redmine and database are all on same machine

redmine from svn (rev 1354)

HW Setup:

Intel Quad Core CPU

4 Gig RAM

This setup works quite well. On a daily use the problem wouldn't show up. Normal checkouts and commits won't activate it.

However I wanted to svnsync remote repository into one managed by the described setup in order to copy it and continue working

with redmine on that project. The repository has ~1200 revisions. The whole process was very slow and memory intensive. At each

30 revisions copied the server's ram was full and the svnsync program stopped working. The only thing that helped was restarting

apache and running svnsync again. When restarting apache the memory usage was dropping to 200mb. And then again and again..

Memory full -> Restart apache -> Memory empty.. I've disabled the authentication (simply allowed everyone access to the svn

repository without user validation) to test and voilla, everything worked fine. The process wasn't using more than 500mb of memory

and the speed improvement was doubtless.

History

#1 - 2008-04-25 11:33 - Liwiusz Ociepa

Problem exist also with older releases of Redmine.pm. I'm afraid that there is memory leak in on of included perl module. Normal checkouts and

commits also triggers that bug, but possibly there are to small to be noticed (my apache grows to something near 600mb of memory - using

authz_svn with ldap it is near 10mb). There are no temporary solution to this bug. It's easy to write script that generate config file for authz_svn but

mod-auth-pgsql cannot use SHA1 encoded password. I'm working on c module that uses as a base mod-auth-pgsql - but it can take some time. It is

possible that bug doesn't exist with MySQL connector - haven't checked that.

#2 - 2008-04-25 15:04 - Liwiusz Ociepa

Interesting - it leaks even when you use dav_svn with mod-auth-pgsql (Without any redmine stuff).

#3 - 2008-04-27 12:37 - Liwiusz Ociepa

Bug exist in dav_svn or libpq or both of them working together. It doesn't show up with MySQL.

#4 - 2008-04-28 22:31 - Liwiusz Ociepa

Can you add do your dsn sslmode=disable and check again?

Eg: PerlSetVar dsn DBI:Pg:dbname=redmine;host=127.0.0.1;sslmode=disable

#5 - 2008-05-19 14:13 - Liwiusz Ociepa

- Status changed from New to Closed

- % Done changed from 0 to 100

Bug disapeard on apache with fixed https://bugs.launchpad.net/ubuntu/+source/apache2/+bug/224945
